local object = require("utility.object")

local baseitem = object:subclass("Item")

local idinc = 1

function baseitem:filldefaults()
	self.name = "GENERIC_ITEM"
	self.displayname = "generic.Item"
	self.stack = 1
	self.repeating = true
	self.speed = 1
	self.id = idinc
	self.texture = love.graphics.newImage("assets/default.png")
	self.color = {}
	self.animation = nil
	self.animationspeed = 0
	self.equip = function(self, player) end
	self.unequip = function(self, player) end
	self.leftuse = function(self, player) end
	self.rightuse = function(self, player) end
end


function baseitem:init(name, data)
	self:filldefaults()
	self.name = name
	self.displayname = name

	local latestID = idinc
	if data.id~=nil then
		latestID = data.id
	end

	idinc = latestID + 1

	-- override defaults
	for label, value in pairs(data) do
		if label == "texture" and type(value) == "string" then
			self["texture"] = love.graphics.newImage("assets/items/"..value)
		else
			self[label] = value
		end
	end
end

baseitem:new("PICKAXE", {
	texture = "pickaxenew.png",
	color = {0.8, 0.4, 0.2},
	speed = 1/30,
	stack = 1,
	specialdata = {usedistance = 8},
	equip = function(self, player)
		player.showMouseTileDistance = 8
	end,
})