local object = require("utility.object")
local jutils = require("utility.jutils")

local entity = object:subclass("Entity")

function entity:init()
	self.texture = love.graphics.newImage("assets/default.png")
	self.textureorigin = jutils.point.new(4,4)
	self.boundingbox = jutils.point.new(4,4)
	self.dead = false
	self.age = 0
	self.scale = jutils.point.new(1, 1)
	self.rotation = 0
	self.health = 100
	self.maxhealth = 100
	self.regenstrength = 0.5
	self.position = jutils.point.new(0,0)
	self.nextposition = jutils.point.new(0,0)
	self.world = nil
	self.unloadtimer = 0
	
end

function entity:collisionCallback(tileid, normal)

end

function entity:dies()

end

function entity:update(dt)
	self.age = self.age + dt

	if self.health <= 0 then
		self.dead = true
		return
	end

	self.health = self.health + (self.regenstrength * dt)

	if self.health > self.maxhealth then
		self.health = self.maxhealth
	end

	
end

local SPRITE_DEBUG = false

function entity:draw()
	love.graphics.setColor(1,1,1)
	love.graphics.draw(
		self.texture,
		self.position.x, self.position.y, self.rotation, self.scale.x, self.scale.y,
		self.textureorigin.x, self.textureorigin.y
	)

	if SPRITE_DEBUG then
		love.graphics.setColor(1, 0, 0)
		love.graphics.points(self.position.x, self.position.y)

		love.graphics.setColor(0, 1, 0)
		love.graphics.points(self.position.x-self.textureorigin.x, self.position.y-self.textureorigin.y)

		love.graphics.setColor(0, 0, 1)
		love.graphics.rectangle("line", self.position.x-self.boundingbox.x, self.position.y-self.boundingbox.y, self.boundingbox.x*2, self.boundingbox.y*2)

	end
end

return entity