local collision = {}

function collision:test(ax, ay, aw, ah, bx, by, bw, bh)

	local distanceX = ax - bx
	local distanceY = ay - by

	local absDistX = math.abs(distanceX)
	local absDistY = math.abs(distanceY)

	local sumWidth = aw + bw
	local sumHeight = ah + bh

	if absDistX >= sumWidth or absDistY >= sumHeight then
		return false -- no intersection
	end

	local sx, sy = sumWidth - absDistX, sumHeight - absDistY

	if sx < sy then
		if sx > 0 then
			sy = 0
		end
	else
		if sy > 0 then
			sx = 0
		end
	end

	if distanceX < 0 then
		sx = -sx
	end
	if distanceY < 0 then
		sy = -sy
	end

	return sx, sy
end

function collision:solve(sx, sy, velx, vely)
	-- find collision normal
	local d = math.sqrt(sx * sx + sy * sy)
	local nx, ny = sx / d, sy / d

	-- relative velocity?
	-- will add later when entities are actually coded
	local vx, vy = velx, vely

	-- penetration speed
	local ps = vx * nx + vy * ny

	if ps <= 0 then
		return nx, ny
	end
end

local function shift(ax, ay, aw, ah)
	local rx = ax - (aw / 2)
	local ry = ay - (ah / 2)
	local rh = ah / 2
	local rw = aw / 2

	return rx, ry, rh, rh
end

return collision