input = {}

local mousex, mousey = 0, 0

function input.setTransformedMouse(dx, dy)
	mousex = dx
	mousey = dy
end

function input.getTransformedMouse()
	return mousex, mousey
end

function mod()
	local m = {}

	m.callbacks = {}

	function m:connect(func)
		self.callbacks[#self.callbacks+1] = func
	end

	function m:call(...)
		for _, func in pairs(self.callbacks) do
			func(...)
		end
	end
	return m
end

input.mousepressed = mod()
input.mousereleased = mod()
input.mousemoved = mod()
input.wheelmoved = mod()
input.textinput = mod()
input.keypressed = mod()
input.keyreleased = mod()

return input