local config = require("config")
local jutils = require("utility.jutils")

local noise = {}


function noise.noise(worldx, worldy, xscale, yscale)
	local basenoise = love.math.noise(worldx/xscale, worldy/yscale)
	basenoise = basenoise - 0.5
	return basenoise
end

function noise.epicnoise(worldx, worldy, frequency, octaves)

	local start = 0

	for i = 1, octaves do
		start = start + (1/i) * noise.noise(worldx, worldy, 1/i*frequency, 1/i*frequency) 
	end

	return start
end

function noise.surfacenoise(x, y)

	local variation = 20
	local minvar = 0.1
	local maxvar = 0.9
	local scalenoise = jutils.math.round(love.math.noise(x/6000), 1)*variation
	local sn = noise.epicnoise((x+1), y, config.generator.SURFACE_FREQUENCY, config.generator.SURFACE_OCTAVES)
	sn = sn * config.generator.SURFACE_GAIN
	
	local surface = math.floor((sn*(config.generator.SURFACE_VARIATION)))+scalenoise


	surface = surface + config.generator.SURFACE_HEIGHT

	return y-surface
end

return noise