local jutils = require("utility.jutils")

local obj = {}

obj.__index = obj
obj.types = {"Object"}

function obj:init(...)
	
end

function obj:new(...)
	local inst = setmetatable({}, {__index = self})
	--inst.super = obj
	inst:init(...)
	return inst
end

function obj:subclass(name)
	local t = setmetatable({}, {__index = self})
	t.__index = t
	t.classname = name
	t.types = jutils.table.copy(self.types)
	table.insert(t.types, name)
	t.super = self
	return t
end

function obj:isA(objectType)
	for i, v in pairs(self.types) do
		if v == objectType then return true end
	end
	return false
end

function obj:__tostring()
	print(self.classname)
end

return obj