local noise = require("utility.noise")
local config = require("config")
local jutils = require("utility.jutils")
local tiles = require("tiles")
local maketree = require("world.structures.maketree")

local treeGroveDensity = 0.12 -- 0 - 1, how dense groves of trees are populated
local treeGroveRarity = 0.4 -- 0 - 1, how common tree groves are
local treeGroveSize = 256 -- the size of groves of trees

return function(world, tilex, tiley)
	--print(world)

	--if (tilex%16) == 0 then
		--world:setTile(tilex, tiley, tiles.SMALL_BRICK.id)
		--print("epic", tilex, tiley)
	--end

	if tiley > config.UNDERGROUND_DEPTH then

		local generatorRoll = math.random(1, 100)

		if generatorRoll == 1 then

			local undergroundHouseNoise = jutils.math.round(noise.noise(tilex, tiley, 32, 32), 2)

			if undergroundHouseNoise == 0 and world:getTile(tilex, tiley) ~= tiles.AIR.id then
				
				local function makeHouseSection(x, y, width, height)
					for dx = 1, width do
						for dy = 1, height do
							world:setTile(x+dx, y+dy, tiles.AIR.id)
						end
					end

					for dx = 1, width do
						world:setTile(x+dx, y, tiles.PLANK.id)
						world:setTile(x+dx, y+height, tiles.PLANK.id)
					end

					for dy = 1, height do
						world:setTile(x+1, y+dy, tiles.PLANK.id)
						world:setTile(x+width, y+dy, tiles.PLANK.id)
					end
				end

				local houseWidth = math.random(16, 32)
				local houseHeight = 6

				makeHouseSection(tilex, tiley, houseWidth, houseHeight)
				makeHouseSection(tilex+math.floor(houseWidth/2), tiley+houseHeight, math.floor(houseWidth/2), houseHeight)

			end
		end
	end


	local surfaceNoiseVal = noise.surfacenoise(tilex, tiley)

	local treeNoise = noise.noise(tilex, tiley, treeGroveSize, treeGroveSize)

	local tree2Noise = noise.noise(tilex, tiley, 16, 16)

	local doTree = math.random()
	if treeNoise > (treeGroveRarity-0.5) and treeGroveDensity > doTree then

		

		if world:getTile(tilex, tiley) == tiles.GRASS.id then
			maketree(world, tilex, tiley)
		end
	end
end